'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.paddingPropTypes = undefined;
exports.removePaddingProps = removePaddingProps;

exports.default = function () {
  for (var _len = arguments.length, options = Array(_len), _key = 0; _key < _len; _key++) {
    options[_key] = arguments[_key];
  }

  return (0, _styleHelper2.default)(options, paddingPropTypes, mapPaddingStyle);
};

var _react = require('react');

var _styleHelper = require('../styleHelper');

var _styleHelper2 = _interopRequireDefault(_styleHelper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var paddingPropTypes = exports.paddingPropTypes = {
  padding: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),
  paddingTop: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),
  paddingLeft: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),
  paddingRight: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),
  paddingBottom: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number])
};

function removePaddingProps(props) {
  return (0, _styleHelper.extractProps)(props, paddingPropTypes)[0];
}

function mapPaddingStyle(key, value) {
  return [key, (0, _styleHelper.parseDimension)(value)];
}